
start                   equ   30000

upper_mem_test          equ   #9800
fill_aa                 equ   #a000

                        org   start

main                    proc

                        call  3435
                        ld    a,2
                        call  #1601

                        call  print_text
                        db    22,1,0
                        db    "Testing in contended RAM...",13
                        db    255

                        ld    a,1
                        ld    ix,test_code
                        call  run_test

                        call  print_text
                        db    "Testing in uncontended RAM...",13
                        db    255

                        ld    hl,test_code
                        ld    de,upper_mem_test
                        ld    bc,testcode_sizeof
                        ldir

                        ld    a,2
                        ld    ix,upper_mem_test
                        call  run_test

                        ret

                        endp

run_test                proc
                        out   (254),a
                        call  _jp_ix

                        ld    a,c
                        or    a
                        jr    z,_mem_faded

                        call  print_text
                        db    "DRAM not faded", 13, 13, 255
                        ret

      _mem_faded        call  print_text
                        db    "DRAM faded", 13, 13, 255
                        ret

      _jp_ix            jp    (ix)
                        endp

test_code               proc
                        di
                        ld    hl,fill_aa
      _fill_loop        ld    (hl),#aa
                        inc   l
                        jr    nz,_fill_loop
                        inc   h
                        jr    nz,_fill_loop

                        xor   a
                        ld    b,#03

      _hold_R_outer     ld    hl,#0000

      _hold_R_inner     xor   a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        ld    r,a
                        dec   hl
                        or    h
                        jr    nz,_hold_R_inner

                        djnz  _hold_R_outer

                        ld    hl,fill_aa
                        ld    bc,#0000
      _aa_cmp_loop      ld    a,(hl)
                        cp    #aa
                        jr    nz,_aa_mismatch

                        inc   hl
                        ld    a,h
                        or    l
                        jr    nz,_aa_cmp_loop

                        ld    bc,#0001

      _aa_mismatch      ei
                        ret

      testcode_sizeof   equ   $-test_code
                        endp

print_hex_16            proc
                        ld    a,h
                        call  print_hex_8
                        ld    a,l
                        call  print_hex_8
                        ret
                        endp

print_hex_8             proc
                        push  af
                        rra
                        rra
                        rra
                        rra
                        call  print_hex_char
                        pop   af
                        call  print_hex_char
                        ret
                        endp

print_hex_char          proc
                        and   15
                        cp    10
                        sbc   a,#69
                        daa
                        rst   16
                        ret
                        endp

print_text              proc
                        pop   de
      _loop             ld    a,(de)
                        inc   de
                        cp    255
                        jr    z,_exit
                        rst   16
                        jr    _loop

      _exit             push  de
                        ret
                        endp

                        end start

